
'## GLOBAL VARIABLES

NL = vbNewLine

Set WshShell = WScript.CreateObject("WScript.Shell")

Set Fso = CreateObject("Scripting.FileSystemObject")

Set WshSysEnv = WshShell.Environment("Process")

basedir=""
user = WshSysEnv("USERNAME")
mode = ""
MULE_HOME = WshSysEnv("MULE_HOME")
CLASSPATH = ""
CLIENT_JAR = ""
JMS_JAR = ""

JAVA_HOME = WshSysEnv("JAVA_HOME")
JAVA = ""
JAVAC = ""

'# Double-quote string
q = """"

'######################################################

Sub echo(str)
   WScript.Echo str
End Sub

'######################################################

Sub set_directory() 

   '# Double-quotes in the path cause problems, so remove them.
   JAVA_HOME = Replace( JAVA_HOME, """", "" )
   echo "JAVA_HOME : " & JAVA_HOME
   
   if JAVA_HOME = "" then
     echo "JAVA_HOME must be set to run the example."
     WScript.quit 1
   end if
   
 
   if NOT fso.FolderExists(JAVA_HOME) then
     echo "JAVA_HOME must point to an actual directory to run the example."
     WScript.quit 1
   end if
   
   JAVA = JAVA_HOME & "\bin\java.exe"
   if NOT fso.FileExists(JAVA) then
        echo "The file: " & JAVA & " must exist to run the example."
        WScript.quit 1
   end if
  
   '# Set MULE_HOME if it isn't set already
   MULE_HOME = Replace( MULE_HOME, """", "" )
   if MULE_HOME = "" then
     if fso.FolderExists("..\mule-1.4.3") then
       MULE_HOME = FSO.GetFolder("..\mule-1.4.3").path
       curdir = FSO.GetFolder(".").path
       parentdir = FSO.GetFolder("..").path
     end if
   end if

   if MULE_HOME = "" then
     echo "MULE_HOME must be set to the Mule Home Directory before running this program.  Exiting."
     WScript.Quit 1
   end if
   
   echo "curdir = " & curdir
   echo "parentdir = " & parentdir
   echo "MULE_HOME = " & MULE_HOME

End Sub

'######################################################

Sub get_ambrosia_client_jar()

  Set libdir = fso.GetFolder (MULE_HOME & "\lib\user")
  Set files = libdir.Files

  Set rx = New RegExp

  rx.Pattern = "ambrosia-client.*.jar"
  rx.IgnoreCase = true

  Dim source()
  idx = -1
  For Each f in files
    if rx.Test (f.Name) then
      idx = idx + 1
      ReDim preserve source(idx)
      source(idx) = f.Path
    end if
  Next

  if idx > 0 then
    echo "Multiple ambrosia client jars found in " & MULE_HOME & "\lib\user"
    WScript.Quit 1
  end if
  
  if idx < 0 then
    echo "No ambrosia client jar found in " & MULE_HOME & "\lib\user"
    WScript.Quit 1
  end if
  
  CLIENT_JAR = source(0)
  echo "Found client jar: " & CLIENT_JAR
  
End Sub

'######################################################

Sub set_classpath()

  JMS_JAR = MULE_HOME & "\lib\user\jms.jar"

  if NOT fso.FileExists(JMS_JAR) then
    echo "jms.jar must be copied to " & JMS_JAR & " before running this program.  Exiting."
    WScript.quit 1
  end if

  get_ambrosia_client_jar

  if NOT fso.FileExists(CLIENT_JAR) then
    echo "The Ambrosia client jar (ambrosia-client-*.jar) must be copied to " & MULE_HOME & "\lib\user\ before running this program.  Exiting."
    WScript.quit 1
  end if

  CLASSPATH = q & ".;" & JMS_JAR & ";" & CLIENT_JAR & q

  echo "CLASSPATH = " & CLASSPATH
  WshSysEnv("CLASSPATH") = CLASSPATH

End Sub

'######################################################

Sub run_java()

  echo "Compiling the AmbMule example from the example package"
  
  jc = q & JAVA_HOME & "\bin\javac.exe" & q & " -cp " & CLASSPATH 
  java = q & JAVA & q & " -cp " & CLASSPATH 
  
  '#WshShell.Run "%comspec% /c " & jc & " AmbMule.java" & q, 4, FALSE

  opts=""

  echo ""
  echo "Run create the Queues used by the example."

  cmd = "%comspec% /c " & q & java & " CreateQ localhost:8001 Administrator Administrator"
  echo "cmd = " & cmd
  WshShell.Run cmd & " muleInQueue & pause 5" & q, 4, TRUE
  WshShell.Run cmd & " muleOutQueue & pause 5" & q, 4, TRUE

End Sub

'######################################################

'########
'# MAIN #
'########

'#echo "### Starting main ..."

set_directory

set_classpath

run_java

echo "### DONE."
