
'## GLOBAL VARIABLES

NL = vbNewLine

'# Set Defaults -- Global variables
Set WshShell = WScript.CreateObject("WScript.Shell")

Set Fso = CreateObject("Scripting.FileSystemObject")

Set WshSysEnv = WshShell.Environment("Process")

basedir=""
mode = ""

JAVA_HOME = WshSysEnv("JAVA_HOME")

MULE_HOME = WshSysEnv("MULE_HOME")
MULE_BASE = WshSysEnv("MULE_BASE")
MULE_LIB  = WshSysEnv("MULE_LIB")
ARGUMENTS = ""

'# Double-quote string
q = """"

'######################################################

Sub echo(str)
   WScript.Echo str
End Sub

'######################################################

Sub print_help() 
   echo ""
   echo "Usage: runMuleEcho.bat [OPTIONS]"
   echo "      -?, -h, --help	Display this help and exit."
   echo "      --durable	Run the test with Durable Subscriptions"
   echo "      -d		  (same as --durable)" 
   echo "      --reliable	Run the test with Reliable Subscriptions"
   echo "      -r		  (same as --reliable)"
   echo "      --queue		Run the test with Queues"
   echo "      -q		  (same as --queue)"
   echo ""
End Sub

'######################################################

Sub print_help_exit() 

  print_help
  WScript.Quit 1

End Sub

'######################################################

Sub parse_arguments() 

   Dim paramName, paramValue, param

   if WScript.Arguments.Count = 0 Then
      print_help_exit
   end if

   count = 0
   for each param in WScript.Arguments
      if count > 0 then
        ARGUMENTS = ARGUMENTS & " " & param
      else
        paramAry = Split( param, "=", 2 )

        paramName = paramAry(0)
        if UBound( paramAry ) = 0 then
           paramValue = ""
        else
           paramValue = paramAry(1)
        end if

        select case paramAry(0)
           case "-h"           print_help_exit
           case "-?"           print_help_exit
           case "-help"        print_help_exit
           case "--help"       print_help_exit
           case "--durable"    mode = "durable"
           case "-d"           mode = "durable"
           case "--reliable"   mode = "reliable"
           case "-r"	       mode = "reliable"
           case "--queue"      mode = "queue"
           case "-q"           mode = "queue"
           case else           echo "ERROR:  Unknown parameter: " & param
  		               print_help_exit
        end select
      end if
      
      count = count + 1
        
   next

End Sub

'######################################################

Sub set_directory() 

  '# Double-quotes in the path cause problems, so remove them.
  JAVA_HOME = Replace( JAVA_HOME, """", "" )
  echo "JAVA_HOME : " & JAVA_HOME

  if JAVA_HOME = "" then
    echo "JAVA_HOME must be set to run the example."
    WScript.quit 1
  end if
  
  if NOT fso.FolderExists(JAVA_HOME) then
    echo "JAVA_HOME must point to an actual directory to run the example."
    WScript.quit 1
  end if
   
  JAVA = JAVA_HOME & "\bin\java.exe"
  if NOT fso.FileExists(JAVA) then
    echo "The file: " & JAVA & " must exist to run the example."
    WScript.quit 1
  end if

  '# Set MULE_HOME if it isn't set already
  MULE_HOME = Replace( MULE_HOME, """", "" )
  if MULE_HOME = "" then
    if fso.FolderExists("..\mule-1.4.3") then
      MULE_HOME = FSO.GetFolder("..\mule-1.4.3").path
    end if
  end if

  if NOT fso.FolderExists(MULE_HOME) then
    if MULE_HOME = "" then
      echo "MULE_HOME must be set to the Mule Home Directory before running this program.  Exiting."
    else
      echo "MULE_HOME is set to a directory that does not exist, MULE_HOME is: " & MULE_HOME & ", Exiting."
    end if
    WScript.Quit 1
  end if

  '# If MULE_BASE is not set, make it MULE_HOME
  if MULE_BASE = "" then
    MULE_BASE = MULE_HOME
  end if

  '# Any changes to the files in .\conf will take precedence over those deployed to $MULE_HOME/lib/user
  MULE_LIB = ".\conf"

  echo "MULE_HOME:" & MULE_HOME
  echo "MULE_BASE:" & MULE_BASE
  echo "MULE_LIB :" & MULE_LIB
  
  WshSysEnv("MULE_HOME") = MULE_HOME
  WshSysEnv("MULE_BASE") = MULE_BASE
  WshSysEnv("MULE_LIB")  = MULE_LIB


End Sub

'######################################################

Sub run_mule()

  echo "Run the Mule echo with mode: " & mode

  configFile=".\conf\echo-config-" & mode & ".xml"
  if NOT fso.FileExists(configFile) then
    echo "Error: Mule configuration file is missing, file: " & configFile
    WScript.quit 1
  end if

  cmd = "%comspec% /c " & q & " " & q & MULE_BASE & "\bin\mule.bat" & q & " -config " & configFile & ARGUMENTS & q
  echo "cmd = " & cmd
  WshShell.Run cmd, 4, FALSE

End Sub

'######################################################

'################
'# MAIN Program #
'################

'#echo " Starting main ..."

parse_arguments

set_directory

run_mule

echo "### DONE."


